
/*
 * libgnet - game net library
 * Copyright (C) 1997 Indrek Mandre 
 *
 * This library is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/socket.h>
#include <netinet/in.h>

#include "gnet.h"
#include "gnet-local.h"

void GN_check_server ( GN_server *serv )
{
 GN_client *cl;
 struct timeval tv;
 int l = serv->tcpsocket;

 FD_ZERO ( &serv->fdchk );
 FD_SET ( serv->tcpsocket, &serv->fdchk );

 cl = serv->clients;

 while ( cl->prev != NULL ) {
 	cl = cl->prev;
 	if ( l < cl->udpsocket ) l = cl->udpsocket;
 	if ( l < cl->tcpsocket ) l = cl->tcpsocket;
 	FD_SET ( cl->tcpsocket, &serv->fdchk );
 	if ( cl->udpsocket != -1 ) FD_SET ( cl->udpsocket, &serv->fdchk );
 }

 tv.tv_usec = 0;	/* Don't wait any time */
 tv.tv_sec = 0;

 if ( select ( l + 1, &serv->fdchk, NULL, NULL, &tv ) ) {

   cl = serv->clients;

   while ( cl->prev != NULL ) {
 	cl = cl->prev;
 	if ( (cl->flags&FLAG_WAIT_ANSWER) && FD_ISSET ( cl->tcpsocket, &serv->fdchk ) ) {
 		struct GN_connection bb;
 		if ( recv ( cl->tcpsocket, &bb, sizeof ( struct GN_connection ), 0 ) > 0 && cl->udpaddress != NULL )
 			((struct sockaddr_in *)cl->udpaddress)->sin_port = htons ( bb.udpport );
 		cl->flags &= ~FLAG_WAIT_ANSWER;
 		FD_CLR ( cl->tcpsocket, &cl->server->fdchk );
 	}
   }
 }

}

int GN_is_new_client ( GN_server *serv )
{

 if ( FD_ISSET ( serv->tcpsocket, &serv->fdchk ) ) return GN_TRUE;

 return GN_FALSE;

}

void GN_check_conn ( GN_conn *ppp )
{
 struct timeval tv;

 FD_ZERO ( &ppp->fdchk );
 FD_SET ( ppp->socket, &ppp->fdchk );
 if ( ppp->udpsocket != -1 ) FD_SET ( ppp->udpsocket, &ppp->fdchk );

 tv.tv_usec = 0;
 tv.tv_sec = 0;

 select ( ppp->udpsocket>ppp->socket?(ppp->udpsocket+1):(ppp->socket+1), &ppp->fdchk, NULL, NULL, &tv );

}

